----------------------------
-- SinStats Configuration --
----------------------------
local AddName, AddonTable = ...
local addVer = "3.2.5"
local byPass

AddonTable.Groups = { "|cffF0851AMelee|r", "|cffF0851ARanged|r", "|cffF0851ASpell|r", "|cffF0851AResistance|r", "|cffF0851AMisc|r" }

function AddonTable:UpdateStatus()
	SinStatsFrame:SetShown(not SinStatsDB.SinHideVar)
	local locked = SinStatsDB.SinLockVar
	SinStatsFrame:SetBackdropColor(1, 1, 1, locked and 0 or 1)
	SinStatsFrame:EnableMouse(not locked)
	SinStatsFrame.DragText:SetShown(not locked)
end

local SinStatsConfig = CreateFrame("frame","SinStatsConfigFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
SinStatsConfig:SetMovable(true)
SinStatsConfig:SetClampedToScreen(true)
SinStatsConfig:SetUserPlaced(true)
SinStatsConfig:Hide()

function AddonTable:ToggleConfig()
	local Configs = {
		AP = { label=" Attack Power", tooltip="|cff00f26dTips and Info!|r\n\nA red |cffd4080cAttack Power|r value indicates that you\nare affected by a debuff related to this stat", },	
		RAP = { label=" Attack Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nA red |cffd4080cAttack Power|r value indicates that you are affected by a debuff related to this stat\nA green |cff00f26dAttack Power|r value indicates that Hunter's Mark ability is applied on your target\n\n|cffF0851AScaling:|r |cffAAD372Hunter's Mark|r", },			
		DMG = { label=" Damage |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nA red |cffd4080cDamage|r value indicates that you\nare affected by a debuff related to this stat\n\n|cffF0851AScaling:|r \n|cffC69B6DBlood Frenzy|r \n|cffFFF468Hemorrhage|r", },
		mDPS = { label=" Damage per Second", tooltip="|cff00f26dTips and Info!|r\n\nDisplays your DPS with Melee Weapons\nA red |cffd4080cDPS|r value indicates that you\nare affected by a debuff related to this stat", },
		RDMG = { label=" Damage |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nA red |cffd4080cDamage|r value indicates that you\nare affected by a debuff related to this stat\n\n|cffF0851AScaling:|r \n|cffC69B6DBlood Frenzy|r \n|cffFFF468Hemorrhage|r", },
		rDPS = { label=" Damage per Second", tooltip="|cff00f26dTips and Info!|r\n\nDisplays your DPS with Range Weapons\nA red |cffd4080cDPS|r value indicates that you\nare affected by a debuff related to this stat", },
		Fire = { label=" Fire Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Fire damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r \n|cff8788EECurse of Elements|r \n|cff3FC7EBFire Vulnerability|r", },		
		Frost = { label=" Frost Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Frost damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r \n|cff8788EECurse of Elements|r", },		
		Arcane = { label=" Arcane Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Arcane damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r \n|cff8788EECurse of Elements|r", },
		Shadow = { label=" Shadow Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Shadow damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r, |cffffffffShadow Weaving|r \n|cff8788EEShadow Vulnerability|r, |cff8788EECurse of Elements|r", },			
		Nature = { label=" Nature Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Nature damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r \n|cff0070DDStormstrike|r", },
		Healing = { label=" Healing Power", tooltip="|cff00f26dTips and Info!|r\n\nIncludes +healing from gear, consumables, enchants and talents", },
		Holy = { label=" Holy Power |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nIncludes Holy damage from gear, consumables, enchants and talents\n\n|cffF0851AScaling:|r \nSpell Power modifiers\n|cffffffffMisery|r \n|cffF48CBASeal of the Crusader (Improved)|r", },				
		Crit = { label=" Critical Strike |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nSpell book Melee Critical Strike value\nAlso represents your Critical Strike in PvP\n\n|cffF0851AScaling:|r \n|cffF48CBASeal of the Crusader (Improved)|r", },    
		CritBoss = { label=" Critical vs Boss |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nMelee Critical Strike value in PvE, against a higher level NPC\nIncludes all Crit Suppressions Auras\n\n|cffF0851ADefault Value:|r NPC +3 Levels\n|cffF0851AScaling:|r \nNPC of +1 to +5 Levels\n|cffF48CBASeal of the Crusader (Improved)|r", },    		
		CritCap = { label=" Critical Cap", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the Melee Critical Strike Cap against a Raid Boss \nbased on the weapons used and other character stats", },    		
		RangedCrit = { label=" Critical Strike", tooltip="|cff00f26dTips and Info!|r\n\nSpell book Ranged Critical Strike value\nAlso represents your Critical Strike in PvP", },
		RangedCritBoss = { label=" Critical vs Boss |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nRanged Critical Strike value in PvE, against a higher level NPC\nIncludes all Crit Suppressions Auras\n\n|cffF0851ADefault Value:|r NPC +3 Levels\n|cffF0851AScaling:|r NPC of +1 to +5 Levels", },    				
		SpellCrit = { label=" Critical Strike |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nSpell book Critical Strike value. Also represents your Critical Strike in PvP\nTalent spell-specific Crit will be colored and appear next to the current value\n\n|cffF0851AScaling:|r \n|cffF48CBASeal of the Crusader (Improved)|r \n|cff3FC7EBWinter's Chill|r", },
		SpellCritBoss = { label=" Critical vs Boss |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nSpell Critical Strike value in PvE, against a higher level NPC\nIncludes all Crit Suppressions Auras\nTalent spell-specific Crit is colored\n\n|cffF0851ADefault Value:|r NPC +3 Levels\n|cffF0851AScaling:|r \nNPC of +1 to +5 Levels\n|cffF48CBASeal of the Crusader (Improved)|r \n|cff3FC7EBWinter's Chill|r", },    						
		Hit = { label=" Hit", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the Melee Hit Chance percentage. Includes all Hit rating sources", },
		RangedHit = { label=" Hit", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the Ranged Hit Chance percentage. Includes all Hit rating sources", },
		HasteMelee = { label=" Haste", tooltip="|cff00f26dTips and Info!|r\n\nHaste bonus percentage from abilities procs, enchants,\ntalents, trinkets, consumables and buffs", },
		weaponSpeed = { label=" Attack Speed", tooltip="|cff00f26dTips and Info!|r\n\nWeapon speed for Main Hand and Off Hand", },
		ArmorPenetration = { label=" Armor Penetration", tooltip="|cff00f26dTips and Info!|r\n\nPercentage of your target's armor that your physical attacks ignore", },		
		Expertise = { label=" Expertise", tooltip="|cff00f26dTips and Info!|r\n\nExpertise reduction to chance to be dodged or parried, in percent for \nboth the Main-hand and the Off-hand", },		
		MeleeMiss = { label=" Miss Chance", tooltip="|cff00f26dTips and Info!|r\n\nMiss chance with melee weapons against an NPC of the same level", },
		MeleeBoss = { label=" Miss vs Boss |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nMiss chance with melee weapons against an NPC of Boss Levels\n\n|cffF0851ADefault Value:|r NPC of +3 Levels\n|cffF0851AScaling:|r NPC of +1 to +5 Levels", },
		Avoidance = { label=" Avoidance |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat!\nThis stat is interactive and will scale based on your current target!|r\n\nChance to avoid Crushing Blows \n\n|cffF0851ADefault Value:|r NPC +3 Levels\n|cffF0851AScaling:|r \nNPC of +1 and +2 Levels \n|cffAAD372Scorpid Sting|r \n|cffFF7C0AInsect Swarm debuffs", },	
		Crushing = { label=" Crushing |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat!\nThis stat is interactive and will scale based on your current target!|r\n\nChance to be hit by a Crushing Blow\n\n|cffF0851ADefault Value:|r NPC +3 Levels\n|cffF0851AScaling:|r \nNPC +1 and +2 Levels\n|cffAAD372Scorpid Sting|r \n|cffFF7C0AInsect Swarm debuffs|r", },			
		HasteRanged = {  label=" Haste", tooltip="|cff00f26dTips and Info!|r\n\nHaste bonus percentage from abilities procs, enchants\ntalents, trinkets, consumables, and buffs", },
		rangedSpeed = {  label=" Attack Speed", tooltip="|cff00f26dTips and Info!|r\n\nWeapon speed of the equipped range weapon", },		
		RangedMiss = { label=" Miss Chance", tooltip="|cff00f26dTips and Info!|r\n\nMiss chance with ranged weapons against an NPC of the same level", },
		RangedBoss = { label=" Miss vs Boss |cff00f26d+|r", tooltip="|cff00f26dSinLive™ Stat! \nThis stat is interactive and will scale based on your current target!|r\n\nMiss chance with range weapons against an NPC of +3 levels\n\n|cffF0851ADefault Value:|r NPC of +3 Levels\n|cffF0851AScaling:|r NPC of +1 to +5 Levels", },
		SpellHit = { label=" Hit", tooltip="|cff00f26dTips and Info!|r\n\nTalent spell-specific Hit is colored", },
		HasteCaster = { label=" Haste", tooltip="|cff00f26dTips and Info!|r\n\nHaste bonus percentage from abilities procs,\ntalents, trinkets, consumables and buffs", },
		SpellMiss = { label=" Miss Chance", tooltip="|cff00f26dTips and Info!|r\n\nMiss chance against an NPC of the same level", },
		SpellBoss = { label=" Miss vs Boss", tooltip="|cff00f26dTips and Info!|r\n\nMiss chance against an NPC of +3 levels with Spells", },
		ManaRegen = { label=" Mana Regen", tooltip="|cff00f26dTips and Info!|r\n\nMana Regeneration per tick (every 2 secs),\nalso known as MP2 (outside 5-sec rule). \nIt reflects the mana bar regeneration", },
		CastingRegen = { label=" Casting Regen", tooltip="|cff00f26dTips and Info!|r\n\nMana Regeneration per tick (every 2 secs) while casting.\nAlso known as MP2 (inside 5-sec rule).\n It reflects the mana bar regeneration", },
		MP5 = { label=" MP5", tooltip="|cff00f26dTips and Info!|r\n\nMana Regeneration per 5 seconds (Outside 5-second rule)", },
		MP5Casting = { label=" Casting MP5", tooltip="|cff00f26dTips and Info!|r\n\nMana Regeneration per 5 seconds while casting (Inside 5-second rule)", },		
		Armor = { label=" Armor", tooltip="|cff00f26dTips and Info!|r\n\nEffective Armor, including all modifiers\nA red |cffd4080cArmor|r value indicates that you are affected by a debuff related to this stat", },
		Resilience = { label=" Resilience", tooltip="|cff00f26dTips and Info!|r\n\nPercentage of periodic damage reduction, chance \nto be critically hit and damage reduction of mana drains \nand critical strikes", },		
		DMGReduc = { label=" Mitigation", tooltip="|cff00f26dTips and Info!|r\n\nPercentage of damage reduction against an NPC of +3 levels" , },
		Defense = { label=" Defense", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the effective Defense skills. Includes all +Defense sources", },
		Dodge = { label=" Dodge", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the chance to Dodge an attack. Includes all Dodge rating sources", },
		Parry = { label=" Parry", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the chance to Parry an attack. Includes all Parry rating sources", },
		Block = { label=" Block", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the chance to Block an attack. Includes all Block rating sources", },
		FireResist = { label=" Fire", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the resistance value of the Fire school of magic\nIncludes all sources", },
		FrostResist = { label=" Frost", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the resistance value of the Frost school of magic\nIncludes all sources", },
		ShadowResist = { label=" Shadow", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the resistance value of the Shadow school of magic\nIncludes all sources", },
		ArcaneResist = { label=" Arcane", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the resistance value of the Arcane school of magic\nIncludes all sources", },	
		NatureResist = { label=" Nature", tooltip="|cff00f26dTips and Info!|r\n\nDisplays the resistance value of the Nature school of magic\nIncludes all sources", },
		Speed = { label=" Movement Speed", tooltip="|cff00f26dTips and Info!|r\n\nThe current movement speed of your character, in real-time.|nA red |cffd4080cSpeed|r value indicates that you are affected by a slowing\neffect or moving at a slower speed than normal", },
		Durability = { label=" Durability", tooltip="|cff00f26dTips and Info!|r\n\nDurability percentage of your currently equipped gear and weapons", },
		Money = { label=" Money", tooltip="|cff00f26dTips and Info!|r\n\nTotal gold in your current character's possession", },		
		Lag = { label=" Latency [ms]", tooltip=false, },
		FPS = { label=" Framerate [FPS]", tooltip=false, },
	}
	for i= 1, #AddonTable.DisplayOrder do
		if not 	Configs[AddonTable.DisplayOrder[i].hud] then
			print("|cffff0000MISSING Config entry: ".. AddonTable.DisplayOrder[i].hud.."|r")
		end
	end
	
	------------------------------------------------
	-- Factory functions for creating check boxes --
	------------------------------------------------
	local function OnEnter(self)
		local parent = self.tooltip and self or self:GetParent()
		GameTooltip:SetOwner(parent, "ANCHOR_LEFT")
		GameTooltip:SetText(parent.tooltip)
	end

	local function OnLeave()
		GameTooltip:Hide()
	end

	local function CreateCheckBox(parent, name, label, key, entry, tooltip)
		local f = CreateFrame("CheckButton", "$parent"..name, parent, "UICheckButtonTemplate")
		f:SetSize(20, 20)
		f.LabelButton = CreateFrame("Button", "$parentButton", f)
		f.LabelButton:SetHighlightTexture("Interface/QuestFrame/UI-QuestTitleHighlight")
		f.LabelButton:GetHighlightTexture():SetBlendMode("ADD")
		f.LabelButton:SetPoint("LEFT", f, "RIGHT", 5, 0)
		f.LabelButton:SetScript("OnClick", function(self)
			self:GetParent():Click()
		end)
		f.Label = f:CreateFontString("$parentLabel", "OVERLAY")
		f.Label:SetFontObject(GameFontNormal)
		f.Label:SetJustifyV("CENTER")
		f.Label:SetTextColor(1, 1, 1, 1)
		f.Label:SetPoint("LEFT", f.LabelButton)
		local w, h = f.Label:GetSize()
		f.LabelButton:SetSize(w+5, h)
		f.key = key
		f.entry = entry
		f:SetChecked(key[entry])
		f:SetScript("OnClick", function(self)
			self.key[self.entry] = self:GetChecked()
			if not self.ignoreUpdate then
				SinStatsFrame.Stats[self.entry]:SetShown(self:GetChecked())
			end
			SinStatsFrame:RedrawStats()
			PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON)
		end)
		f:SetScript("OnDisable", function(self)
			self.Label:SetAlpha(0.5)
		end)
		f:SetScript("OnEnable", function(self)
			self.Label:SetAlpha(1)
		end)
		function f:SetText(text)
			self.Label:SetText(text)
			self.LabelButton:SetSize(self.Label:GetSize())
		end
		f:SetText(label)
		if tooltip then
			f.tooltip = tooltip
			f:SetScript("OnEnter",  OnEnter)
			f:SetScript("OnLeave",  OnLeave)
			f.LabelButton:SetScript("OnEnter",  OnEnter)
			f.LabelButton:SetScript("OnLeave",  OnLeave)
		end
		return f
	end

	----------------------------------------------------
	-- Factory functions for creating sheets and tabs --
	----------------------------------------------------
	local function TabOnClick(self) 
		PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
		local ID = self:GetID()
		self:SetAlpha(1)
		self.widgets:Show()
		local parent = self:GetParent()
		for i=1, #parent.Tabs do
			if i ~= ID then
				parent.Tabs[i]:SetAlpha(0.5)
				parent.Tabs[i].widgets:Hide()
			end
		end
	end
     
	local function CreateTab(id, parent, text)
		local f = CreateFrame("Button", "$parentTab"..id, parent, "ConfigCategoryButtonTemplate")
		f:Hide()
		tinsert(parent.Tabs, f)
		f:SetID(id)
		f:SetText(text)
		local Text = _G[f:GetName().."NormalText"]
		Text:ClearAllPoints()
		Text:SetAllPoints()
		Text:SetJustifyH("CENTER")
		local width = parent:GetWidth() - 20
		f:SetSize(width / 6, Text:GetHeight() + 10)
		f:SetHighlightTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
		if id == 1 then
			f:SetPoint("TOPLEFT",parent,"TOPLEFT", 0, 0)
		else
			f:SetPoint("LEFT",parent.Tabs[id-1],"RIGHT", 0, 0)
		end
		f.widgets = CreateFrame("Frame", nil, f)
		f.widgets:Hide()
		f.widgets:SetSize(parent:GetWidth(), parent:GetHeight() - f:GetHeight()) 
		f.widgets:SetPoint("TOPLEFT", parent.Tabs[1], "BOTTOMLEFT")
		f:SetScript("OnClick", TabOnClick)
		f:Show()
		return f
	end

	---------------------------------------
	-- Factory functions for other stuff --
	---------------------------------------
	local function CreateSheetLabel(parent, text)
		local f = parent:CreateFontString("$parentLabel", "OVERLAY");
		f:SetFontObject("GameFontHighlight");
		f:SetText(text)
		return f
	end

	local function AddCheckBoxes(sheet, group, colwidth, rowoffset, coloffset)
		local Entries = {}
		for i=1, #AddonTable.DisplayOrder do
			if AddonTable.DisplayOrder[i].grp == group then
				tinsert(Entries, i)
			end
		end
		local row = rowoffset
		local col = coloffset
		local colcount = 1
		local rowmax = math.floor(#Entries/3)
		local over = mod(#Entries, 3)
		local rowcount = 0
		for i=1, #Entries do 
			local Settings = AddonTable.DisplayOrder[Entries[i]]
			local ConfigSettings = Configs[Settings.hud]
			local f = CreateCheckBox(sheet, Settings.hud, Settings.icon..ConfigSettings.label, SinStatsDB.Stats, Settings.hud, ConfigSettings.tooltip)
			f:SetPoint("TOPLEFT", sheet, col, row)
			rowcount = rowcount + 1
			if ((over > 0 and colcount <= over) and rowcount == rowmax+1) or (colcount > over and rowcount == rowmax) then
				colcount = colcount + 1
				col = col + colwidth
				row = rowoffset
				rowcount = 0
			else
				row = row - 25
			end
		end
	end

	-------------------------------------------
	-- Hide/Show or Create the config. frame --
	-------------------------------------------
	if SinStatsConfig.Init then
		SinStatsConfig:SetShown(not SinStatsConfig:IsShown())
		return
	end
	local f = SinStatsConfig
	f.Init = true
	f:Show()
	f:SetBackdrop({
		bgFile="Interface/DialogFrame/UI-DialogBox-Background-Dark",
		edgeFile="Interface/DialogFrame/UI-DialogBox-Background-Dark",
		tile=1, tileSize=0, edgeSize=5,
	 })
	f:SetBackdropColor(1,1,1,1)
	f:SetWidth(620)
	f:SetHeight(325)
	f:SetPoint("CENTER",UIParent)
	f:EnableMouse(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnDragStart", function(self) self:StartMoving() end)
	f:SetScript("OnDragStart", function(self) self:StartMoving() end)
	f:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	f:SetFrameStrata("FULLSCREEN_DIALOG")
	tinsert(UISpecialFrames, "SinStatsConfigFrame")
	f.Close = CreateFrame('Button', '$parentClose', f, "UIPanelCloseButton")
	f.Close:SetPoint('TOPRIGHT', 0,0)
	f.Close:SetSize(25, 25)
	f.Close:SetScript('OnClick', function(self)
		self:GetParent():Hide()
	end)
	
	f.Title = f:CreateFontString(nil, "OVERLAY");
	f.Title:SetFontObject("GameFontHighlight");
	f.Title:SetPoint("TOP", SinStatsConfig, "TOP", 0, -5);
	f.Title:SetText("|cff00f26dSinStats :|r |cffF0851ABurning Crusade Classic|r");		

	local TabSettings = SinStatsDB.Stats
 	f.Tabs = {}
	local tab = CreateTab(1, f, "|cffF0851AHUD|r") 
	tab:ClearAllPoints() 
	tab:SetPoint("TOPLEFT", 10, -40)
	local sheet = tab.widgets
	local colWidth = (sheet:GetWidth()-10)/3
	local colOffset = 35
	local rowOffset = -50
	
	sheet.Reset = CreateFrame('Button', '$parentReset', sheet, "UIPanelButtonTemplate")
	sheet.Reset:SetSize(115, 25)
	sheet.Reset:SetText("Reset Position")
	sheet.Reset:SetPoint("BOTTOMLEFT", -1, 43)
	sheet.Reset:SetScript('OnClick', function(self)
		StaticPopup_Show("SINSTATS_HUD_RESET")
	end)	
	
	sheet.SigVer = CreateSheetLabel(sheet, "|cff00f26d" .. addVer .. "|r");	
	sheet.SigVer.ignoreUpdate = true
	sheet.SigVer:SetFontObject("GameFontHighlightSmall");	
	sheet.SigVer:SetPoint('BOTTOMRIGHT', -15, 43);				

	sheet.Label = CreateSheetLabel(sheet, "|cffF0851AHUD Settings|r")
	sheet.Label:SetPoint("TOP", sheet, "TOP", 0, -20);	

	------------------
	-- Enable Frame --
	------------------	
	sheet.Enable = CreateCheckBox(sheet, "Enable", "", SinStatsDB, "SinHideVar", "Disable the Stats Frame")
	sheet.Enable.ignoreUpdate = true
	sheet.Enable:SetPoint('TOPLEFT', 105, -50)
	sheet.Enable:HookScript('OnClick', function(self)
	        local Setting = self.key[self.entry]
		self:SetText(Setting and "HUD [|cffd4080cDisabled|r]" or "HUD [|cff00f26dEnabled|r]")
		AddonTable:UpdateStatus()
		if Setting and not self:GetParent().Locked:GetChecked() then
			--self:GetParent().Locked:Click()
		end
		self:GetParent().Locked:SetEnabled(not Setting)
	end)

	----------------
	-- Lock frame --
	----------------	
	sheet.Locked = CreateCheckBox(sheet, "Locked", "", SinStatsDB, "SinLockVar", "Locks/Unlocks the Stats frame to move it")
	sheet.Locked.ignoreUpdate = true
 	sheet.Locked:SetPoint('TOP', 50, -50)
 	sheet.Locked:HookScript('OnClick', function(self)
		local Locked = self.key[self.entry]
         	self:SetText(Locked and "HUD [|cffd4080cLocked|r]" or "HUD [|cff00f26dUnlocked|r]")
         	AddonTable:UpdateStatus()
	end)
	sheet.Locked:GetScript('OnClick')(sheet.Locked)
	sheet.Enable:GetScript('OnClick')(sheet.Enable)

	--------------------
	-- Minimap button --
	--------------------	
	sheet.mmToggle = CreateCheckBox(sheet, "mmToggle", "", SinStatsDB.minimap, "hide", "Toggle the minimap button")
	sheet.mmToggle:SetPoint("TOP", sheet.Enable, "BOTTOM", 0, -5);
	sheet.mmToggle.ignoreUpdate = true		
	if SinStatsDB.minimap.hide then
		byPass = true
	else	
		byPass = false
	end
	sheet.mmToggle:SetScript("OnClick", function(self)
    self.key[self.entry] = not self:GetChecked()
    local mmHide = self.key[self.entry]
    self:SetText(mmHide and "Minimap Button [|cffC41E3ADisabled|r]" or "Minimap Button [|cff00f26dEnabled|r]")
    if SinStatsDB.minimap.hide and byPass then
		AddonTable.sshMiniButton:Hide("SinStats") 
	elseif SinStatsDB.minimap.hide and not byPass then
		LibDBIcon10_SinStats:Hide()
    elseif not SinStatsDB.minimap.hide and byPass then
		AddonTable.sshMiniButton:Show("SinStats") 
	elseif not SinStatsDB.minimap.hide and not byPass then		
		LibDBIcon10_SinStats:Show()
    end
	end)          
	sheet.mmToggle:SetChecked(not SinStatsDB.minimap.hide)
	sheet.mmToggle:GetScript('OnClick')(sheet.mmToggle)
	
	----------------
	-- Stat Order --
	----------------	
	sheet.Order = CreateCheckBox(sheet, "Order", "", SinStatsDB, "GroupOrder", "Order the stats using the default order\n or by group (Melee, Ranged, Spell, etc.)")
	sheet.Order:SetPoint("TOP", sheet.mmToggle, "BOTTOM", 0, -5)
	sheet.Order.ignoreUpdate = true	
	sheet.Order:HookScript("OnClick", function(self)	
	self:SetText(self.key[self.entry] and "Stats Order [|cffF2A427Group|r]" or "Stats Order [|cff00f26dDefault|r]")	
	end)
	sheet.Order:GetScript("OnClick")(sheet.Order)			

	----------------
	-- Stat Icons --
	----------------	
	sheet.Icons = CreateCheckBox(sheet, "Icons", "", SinStatsDB, "IconVar", "Toggles the icons on the HUD")
	sheet.Icons.ignoreUpdate = true
 	sheet.Icons:SetPoint('TOP', sheet.Locked, 'BOTTOM', 0, -5)
	sheet.Icons:HookScript("OnClick", function(self)
		self:SetText(self.key[self.entry] and "Stats Icons [|cff00f26dEnabled|r]" or "Stats Icons [|cffd4080cDisabled|r]")
		SinStatsFrame.AddIcons = self.key[self.entry]
		AddonTable:RunAllEvents()
		SinStatsFrame:GetScript("OnUpdate")(SinStatsFrame, 5)
	end)		
	sheet.Icons:GetScript('OnClick')(sheet.Icons)	

	------------------	
	-- Text Outline --
	------------------	
	sheet.Outline = CreateCheckBox(sheet, "Outline", "", SinStatsDB, "OutlineVar", "Toggle between Normal or Thick outline text")
	sheet.Outline:SetPoint("TOP", sheet.Icons, "BOTTOM", 0, -5)
	sheet.Outline.ignoreUpdate = true	
	sheet.Outline:HookScript("OnClick", function(self)	
		self:SetText(self.key[self.entry] and "Text Ouline [|cff0489d1Thick|r]" or "Text Outline [|cff00f26dNormal|r]")	
		SinStatsFrame:ResizeStats()
	end)
	sheet.Outline:GetScript("OnClick")(sheet.Outline)		

	--------------------
	-- Text Alignment --
	--------------------	
	sheet.Direction = CreateCheckBox(sheet, "Direction", "", SinStatsDB, "SinDirection", "Change the stats text's alignment and rows")
    sheet.Direction.ignoreUpdate = true
    sheet.Direction:SetPoint('TOP', sheet.Outline, 'BOTTOM', 0, -5)
    sheet.Direction:HookScript('OnClick', function(self)
        local Setting = self.key[self.entry]
        self:SetText(Setting and "Text Alignment [|cffF2A427Horizontal|r]" or "Text Alignment [|cff00f26dVertical|r]")
        SinStatsFrame:RedrawStats()
        self:GetParent().Rows:SetShown(self:GetChecked())
    end)
    sheet.Direction:SetText(SinStatsDB.SinDirection and "Text Alignment [|cffF2A427Horizontal|r]" or "Text Alignment [|cff00f26dVertical|r]")

	---------------	
	-- Text Rows --
	---------------	
	sheet.Rows = CreateFrame("Slider", "SinStatsSlider", sheet, 'OptionsSliderTemplate')
    sheet.Rows:SetShown(SinStatsDB.SinDirection)
    sheet.Rows:SetPoint("TOPLEFT", sheet.Direction, "BOTTOMLEFT", 35, -23)
    sheet.Rows.Low:SetText('1'); 
    sheet.Rows.High:SetText('5');   
    sheet.Rows.Text:SetText('Stats Rows');
    sheet.Rows:SetMinMaxValues(1, 5)
    sheet.Rows:SetValueStep(1)
    sheet.Rows.key = SinStatsDB
    sheet.Rows.entry = "StatRows"
    sheet.Rows:SetValue(SinStatsDB.StatRows or 1)
    sheet.Rows.Label = sheet.Rows:CreateFontString(nil, "OVERLAY");
    sheet.Rows.Label:SetFontObject("GameFontHighlightSmall");
    sheet.Rows.Label:SetPoint("TOP", sheet.Rows, "BOTTOM", 0, -5);     
    sheet.Rows:SetScript("OnValueChanged", function (self)
        local value = math.floor(self:GetValue())
        self.key[self.entry] = value
        SinStatsFrame:RedrawStats()
        self.Label:SetText("Current: " .. self.key[self.entry])
    end)
    sheet.Rows:GetScript("OnValueChanged")(sheet.Rows)	

	----------------	
	-- Text Style --
	----------------	
	sheet.Abbreviate = CreateCheckBox(sheet, "Abbreviate", "", SinStatsDB, "SinAbrev", "Toggle between Normal or Abbreviated Stats Text")
	sheet.Abbreviate:SetPoint("TOP", sheet.Order, "BOTTOM", 0, -5)
	sheet.Abbreviate.ignoreUpdate = true	
	sheet.Abbreviate:HookScript("OnClick", function(self)	
	self:SetText(self.key[self.entry] and "Text Style [|cffF2A427Short|r]" or "Text Style [|cff00f26dNormal|r]")	
	AddonTable:RunAllEvents()
	end)
	sheet.Abbreviate:GetScript("OnClick")(sheet.Abbreviate)		

	---------------	
	-- Text Size --
	---------------
	sheet.Size = CreateFrame("Slider", "SinStatsSlider", sheet, 'OptionsSliderTemplate')
	sheet.Size:SetPoint('TOP', sheet.Abbreviate, 'BOTTOM', 85, -23)
	sheet.Size.Low:SetText('8'); 
	sheet.Size.High:SetText('40');   
	sheet.Size.Text:SetText('HUD Text Size');
	sheet.Size:SetMinMaxValues(8, 40)
	sheet.Size:SetValueStep(1)
	sheet.Size.key = SinStatsDB
	sheet.Size.entry = "StatFontSize"
	sheet.Size:SetValue(SinStatsDB.StatFontSize)
	sheet.Size.Label = sheet.Size:CreateFontString(nil, "OVERLAY");
	sheet.Size.Label:SetFontObject("GameFontHighlightSmall");
	sheet.Size.Label:SetPoint("TOP", sheet.Size, "BOTTOM", 0, -5);		
	sheet.Size:SetScript("OnValueChanged", function (self)
		local value = math.floor(self:GetValue())
		self.key[self.entry] = value
		SinStatsFrame:ResizeStats()
		self.Label:SetText("Current: " .. self.key[self.entry])
	end)
	sheet.Size:GetScript("OnValueChanged")(sheet.Size)

	for grp=1, #AddonTable.Groups do
		tab = CreateTab(grp+1, f, AddonTable.Groups[grp])
		sheet = tab.widgets 
		sheet.Label = CreateSheetLabel(sheet, "|cffF0851A"..AddonTable.Groups[grp].." Settings|r")
		sheet.Label:SetPoint("TOP", sheet, "TOP", 0, -20);
		AddCheckBoxes(sheet, grp, colWidth, rowOffset, colOffset)
	end
	
	TabOnClick(f.Tabs[1])
end

SinStatsOptions = {};

SinStatsOptions.panel = CreateFrame( "Frame", "SinStatsOptionsPanel", UIParent );
SinStatsOptions.panel.name = "SinStats";
InterfaceOptions_AddCategory(SinStatsOptions.panel);


local maintitle = SinStatsOptions.panel:CreateFontString("MainTitle", "OVERLAY", "GameFontHighlightLarge")
maintitle:SetPoint("TOP", "SinStatsOptionsPanel", "TOP", 0, -15)
maintitle:SetText("|cff00f26dSinStats|r")
maintitle:SetFont("Fonts\\FRIZQT__.TTF", 45)

local wowversion = SinStatsOptions.panel:CreateFontString("WowVersion", "OVERLAY", "GameFontHighlightLarge")
wowversion:SetPoint("TOP", "MainTitle", "BOTTOM", 0, -10)
wowversion:SetText("|cffF2A427Burning Crusade Classic|r")
wowversion:SetFont("Fonts\\FRIZQT__.TTF", 30)

local OptionButton = CreateFrame('Button', '$parentSinStatsOptionsPanel', SinStatsOptionsPanel, "UIPanelButtonTemplate")
OptionButton:SetPoint("TOP", "WowVersion", "BOTTOM", 0, -40)
OptionButton:SetSize(160, 25)
OptionButton:SetText("|cffFFFFFFOpen SinStats Settings|r")
OptionButton:SetScript('OnClick', function(self)
	InterfaceOptionsFrame:Hide()
	HideUIPanel(GameMenuFrame)
	AddonTable:ToggleConfig()
end)

local tipText = SinStatsOptions.panel:CreateFontString("TipText", "OVERLAY", "GameFontHighlight")
tipText:SetPoint("TOP", "WowVersion", "BOTTOM", 0, -150)
tipText:SetText("|cffF2A427The settings panel can be accessed with the commands " .. "|cff00f26d/sinstats|r" .. " or " .. "|cff00f26d/ss|r")

local tipTextSnd = SinStatsOptions.panel:CreateFontString("TipTextSnd", "OVERLAY", "GameFontHighlight")
tipTextSnd:SetPoint("TOP", "TipText", "BOTTOM", 0, -3)
tipTextSnd:SetText("|cffF2A427The" .." |cff00f26dminimap button|r" .. " can also be used to quickly access the settings.|r")

local VersionText = SinStatsOptions.panel:CreateFontString("VersionText", "OVERLAY", "GameFontHighlight")
VersionText:SetPoint("TOP", "TipTextSnd", "BOTTOM", 0, -70)
VersionText:SetText("|cffF2A427Version:|r " .. "|cff00f26d" .. addVer .. "|r")

local authorText = SinStatsOptions.panel:CreateFontString("authorText", "OVERLAY", "GameFontHighlight")
authorText:SetPoint("TOP", "VersionText", "BOTTOM", 0, -10)
authorText:SetText("|cffF2A427Author:|r |cff00f26dSinba|r")